Skip to main content

Stack - Question 2

Leetcode 42. Trapping Rain Water

Given n non-negative integers representing an elevation map where the width of each bar is 1, compute how much water it can trap after raining.

Constraints:

n == height.length

1 <= n <= 2 * 10^4

0 <= height[i] <= 10^5


Analysis:

This a classic question for interview.

If the water can be trapped at one position, then it requires there are two higher integers on its both side. So the question becomes how to decide the two sides.

We can use two vectors to record the largest integer so far: one is vector<int> left and the other is vector<int> right,

1. left[i] represents the largest elements so far from the left side;

2. right[i] represents the largest elements so far from the right side;

(Note: this is a very common trick used in dynamic programming.)

After having this information, we can do a third scan: for each element, just need to pick up the difference between nums[i] and the min(left[i], right[i]).

The time complexity is O(3N), and the space complexity is O(2N).


See the code below:


class Solution {
public:
    int trap(vector<int>& height) {
        int res = 0, n = height.size();
        vector<int> left(n+1, 0), right(n+1, 0);
        for(int i=0; i<n; ++i) {
            left[i+1] = max(height[i], left[i]);
        }
        for(int i=n-1; i>=0; --i) {
            right[i] = max(height[i], right[i+1]);
        }
        for(int i=0; i<n; ++i) {
            res += max(min(left[i+1], right[i]) - height[i], 0);
        }
        return res;
    }
};


The space and number of scanning can be further optimized. For example, we can find the maximum number first, which can then divide the array into two parts: one is on the left, the other is on the right side. 
The largest integer is always the "right wall" for the numbers on its left side, and the "left wall" for the numbers on its right side.

So we just need to find the other wall for each numbers.

The time complexity is O(2N) (yes, there are 3 for loops, but only 2N), and the space complexity is O(1).

See the code below:

class Solution {
public:
    int trap(vector<int>& height) {
        int res = 0, n = height.size(), id = 0, left = 0, right = n-1;
        for(int i=1; i<n; ++i) {
            if(height[i] > height[id]) id = i;
        }
        for(int i=1; i<id; ++i) {
            if(height[i] > height[left]) left = i;
            res += height[left] - height[i];
        }
        for(int i=n-1; i>id; --i) {
            if(height[i] > height[right]) right = i;
            res += height[right] - height[i];
        }
        return res;
    }
};

If use a stack, we just need to scan the array once. 

There are some key observations:
1. If all the numbers on its left side are smaller, then there is no way for one number to contribute rain water;
2. If we keep a decreasing order for the number in a stack, once we meet with a larger element, then we can determine the trapped water just between its closest left and right walls easily;
3. The rain water trapped due to other possible left and right walls can still be calculated, since we keep the index in the stack. When calculate the contribution, we use the formula: height diff * width.

In the above two method, we calculate the contribution from each number "vertically", which means all the rain water on top of one number; while using a stack, we calculate the contribution from each number "horizontally", which means we slice the water trapped into different rows, and add them together when popping out the corresponding walls from the stack.

The time complexity is O(N) (yes, only one scan), and the space complexity is O(N) as well.

See the code below:

class Solution {
public:
    int trap(vector<int>& height) {
        int res = 0, n = height.size();
        stack<int> sk;
        for(int i=0; i<n; ++i) {
            while(sk.size() && height[sk.top()] < height[i]) {
                auto t = sk.top();
                sk.pop();
                if(sk.size()) {
                    // height * width
                    res += (min(height[i], height[sk.top()]) - height[t]) * (i - sk.top() - 1);
                }
            }
            sk.push(i);
        }
        return res;
    }
};


 Upper Layer

Comments

Popular posts from this blog

Segment Tree

Segment tree can be viewed as an abstract data structure which using some more space to trade for speed. For example, for a typical question with O(N^2) time complexity, the segment tree method can decrease it to O(N*log(N)).  To make it understandable, let us consider one example. Say we have an integer array of N size, and what we want is to query the maximum with a query range [idx1, idx2], where idx1 is the left indexes, and idx2 is the right indexes inclusive. If we only do this kind of query once, then we just need to scan through the array from idx1 to idx2 once, and record the maximum, done. The time complexity is O(N), which is decent enough in most cases even though it is not the optimal one (for example, with a segment tree built, the time complexity can decrease down to O(log(N))). However, how about we need to query the array N times? If we continue to use the naïve way above, then the time complexity is O(N^2), since for each query we need to scan the query range once...

Bit Manipulation - Example

  Leetcode 136 Single Number Given a non-empty array of integers nums, every element appears twice except for one. Find that single one. You must implement a solution with a linear runtime complexity and use only constant extra space. Constraints: 1 <= nums.length <= 3 * 10^4 -3 * 10^4 <= nums[i] <= 3 * 10^4 Each element in the array appears twice except for one element which appears only once. Analysis: If there is no space limitation, this question can be solved by counting easily. But counting requires additional space. Here we can use xor (^) operation based on some interesting observations:  A^A = 0, here A is any number A^0 = A, here A is any number Since all the number appears twice except one, then all the number appear even numbers will be cancelled out, and only the number appears one time is left, which is what we want. See the code below: class Solution { public: int singleNumber(vector<int>& nums) { int res = 0; for(auto ...

Rolling Hash

Rolling hash is one common trick used to increase efficiency of substring comparisons by compressing (or hashing) a string into a integer. After this step, we can compare two strings directly without comparing each chars. So the efficiency can be increased from O(N) to O(1). So how to implement the rolling hash? First we need to choose a base for the expansion and a modulo to mod. The basic formula is (suppose the window is n, and the rolling direction is from left to right), HashVal = (A1*p^(n-1) + A2*p^(n-2) + ... + An-1*p^1 + An*p^0)%mod where HashVal is the hash value, Ai is the ith element, p is the base, and mod is the modulo. To avoid collision as much as we can, p and modulo usually need to be large prime numbers. One corner case is that the base order in the above formula cannot be reversed. Or to be more clear, if the rolling direction is from left to right in an array, the first element should be in the highest order of the base, or times p^(n-1), and the last element times ...